/*	Copyright (C) 2003-2013 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __surface_SurfaceCurvesMaya_h__
#define __surface_SurfaceCurvesMaya_h__

namespace fe
{

/**************************************************************************//**
	@brief Maya Curve Primitives

	@ingroup maya
*//***************************************************************************/
class FE_DL_EXPORT SurfaceCurvesMaya: public SurfaceCurves
{
	public:
							SurfaceCurvesMaya(void);
virtual						~SurfaceCurvesMaya(void);

							//* As Protectable
virtual	Protectable*		clone(Protectable* pInstance=NULL);

							//* Maya specific
		void				setMeshData(const MDataHandle a_meshData)
							{
								m_meshData=a_meshData;
							}
const	MDataHandle			meshData(void)
							{	return m_meshData; }
		void				setMesh(MFnMesh* a_pFnMesh)
							{
								m_pFnMesh=a_pFnMesh;
							}

		void				setSubIndex(I32 a_subIndex)
							{	m_subIndex=a_subIndex; }
		I32					subIndex(void) const
							{	return m_subIndex; }

		void				setGroup(String a_group)
							{	m_group=a_group; }
		String				group(void) const
							{	return m_group; }

	protected:

virtual	void				cache(void);

	private:

		MDataHandle			m_meshData;
		MFnMesh*			m_pFnMesh;
		String				m_group;
		I32					m_subIndex;
};

} // namespace

#endif /* __surface_SurfaceCurves_h__ */
